! O'Mega scattering amplitudes for the processes
!
!   allowed: (after merging flavor and color states)
!
!     gl/1/2 gl/2/3 -> gl/4/3 gl/5/4 gl/1/5
!
! in Gauged Colorization Functor ( minimal electroweak standard model in unitarity gauge )
!
module test
  use omega_kinds !NODEP!
  use omega95 !NODEP!
  use omega_parameters !NODEP!
  use parameters
  use omega_parameters_whizard
  implicit none
  private
  public :: scatter_nonzero,  scatter_diagonal_nonzero, scatter_diagonal_colored_nz, &
     scatter_colored_nonzero
  public :: allocate_zero
  interface allocate_zero
     module procedure allocate_zero_1, allocate_zero_2
  end interface
  public :: allocate_zero_1, allocate_zero_2
  public :: number_particles, number_particles_in, number_particles_out
  public :: number_spin_states, number_spin_states_in, number_spin_states_out, &
     spin_states, spin_states_in, spin_states_out
  public :: number_flavor_states, number_flavor_states_in,  number_flavor_states_out, &
     flavor_states,  flavor_states_in, flavor_states_out
  public :: number_flavor_zeros, number_flavor_zeros_in, number_flavor_zeros_out, &
     flavor_zeros, flavor_zeros_in, flavor_zeros_out
  public :: number_color_flows, color_flows, anticolor_flows
  public :: create, reset, destroy
  ! DON'T EVEN THINK of removing the following!
  ! If the compiler complains about undeclared
  ! or undefined variables, you are compiling
  ! against an incompatible omega95 module!
  integer, dimension(6), parameter, private :: require =  (/ omega_spinors_2003_03_A, &
     omega_spinor_cpls_2003_03_A,  omega_vectors_2003_03_A, omega_polarizations_2003_03_A, &
     omega_couplings_2003_03_A, omega_utils_2003_03_A /)

  integer, parameter, private :: n_prt     = 5
  integer, parameter, private :: n_in      = 2
  integer, parameter, private :: n_out     = 3
  integer, parameter, private :: n_cflow   = 24
  integer, parameter, private :: n_flv     = 1
  integer, parameter, private :: n_flv_in  = 1
  integer, parameter, private :: n_flv_out = 1
  integer, parameter, private :: n_hel     = 32
  integer, parameter, private :: n_hel_in  = 4
  integer, parameter, private :: n_hel_out = 8

  logical, parameter, private :: F = .false.
  logical, parameter, private :: T = .true.

  integer, dimension(n_prt), parameter, private :: s0001 = (/ -1, -1, -1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0002 = (/ -1, -1, -1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0003 = (/ -1, -1, -1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0004 = (/ -1, -1, -1,  1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0005 = (/ -1, -1,  1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0006 = (/ -1, -1,  1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0007 = (/ -1, -1,  1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0008 = (/ -1, -1,  1,  1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0009 = (/ -1,  1, -1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0010 = (/ -1,  1, -1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0011 = (/ -1,  1, -1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0012 = (/ -1,  1, -1,  1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0013 = (/ -1,  1,  1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0014 = (/ -1,  1,  1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0015 = (/ -1,  1,  1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0016 = (/ -1,  1,  1,  1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0017 = (/  1, -1, -1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0018 = (/  1, -1, -1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0019 = (/  1, -1, -1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0020 = (/  1, -1, -1,  1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0021 = (/  1, -1,  1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0022 = (/  1, -1,  1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0023 = (/  1, -1,  1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0024 = (/  1, -1,  1,  1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0025 = (/  1,  1, -1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0026 = (/  1,  1, -1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0027 = (/  1,  1, -1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0028 = (/  1,  1, -1,  1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0029 = (/  1,  1,  1, -1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0030 = (/  1,  1,  1, -1, &
     1 /)
  integer, dimension(n_prt), parameter, private :: s0031 = (/  1,  1,  1,  1, &
     -1 /)
  integer, dimension(n_prt), parameter, private :: s0032 = (/  1,  1,  1,  1, &
     1 /)
  integer, dimension(n_prt,n_hel), parameter, private :: table_spin_states =  &
     reshape ( (/ s0001, s0002, s0003, s0004, s0005, s0006, s0007, s0008, s0009, &
     s0010, s0011, s0012, s0013, s0014, s0015, s0016, s0017, s0018, s0019,   &
     s0020, s0021, s0022, s0023, s0024, s0025, s0026, s0027, s0028, s0029,   &
     s0030, s0031, s0032 /), (/ n_prt, n_hel /) )
  integer, dimension(n_in), parameter, private :: si0001 = (/ -1, -1 /)
  integer, dimension(n_in), parameter, private :: si0002 = (/ -1,  1 /)
  integer, dimension(n_in), parameter, private :: si0003 = (/  1, -1 /)
  integer, dimension(n_in), parameter, private :: si0004 = (/  1,  1 /)
  integer, dimension(n_in,n_hel_in), parameter, private :: table_spin_states_in  &
     =  reshape ( (/ si0001, si0002, si0003, si0004 /), (/ n_in, n_hel_in /) )
  integer, dimension(n_out), parameter, private :: so0001 = (/ -1, -1, -1 /)
  integer, dimension(n_out), parameter, private :: so0002 = (/ -1, -1,  1 /)
  integer, dimension(n_out), parameter, private :: so0003 = (/ -1,  1, -1 /)
  integer, dimension(n_out), parameter, private :: so0004 = (/ -1,  1,  1 /)
  integer, dimension(n_out), parameter, private :: so0005 = (/  1, -1, -1 /)
  integer, dimension(n_out), parameter, private :: so0006 = (/  1, -1,  1 /)
  integer, dimension(n_out), parameter, private :: so0007 = (/  1,  1, -1 /)
  integer, dimension(n_out), parameter, private :: so0008 = (/  1,  1,  1 /)
  integer, dimension(n_out,n_hel_out), parameter, private :: table_spin_states_out  &
     =  reshape ( (/ so0001, so0002, so0003, so0004, so0005, so0006, so0007, &
     so0008  /), (/ n_out, n_hel_out/) )

  integer, dimension(n_prt), parameter, private ::  f0001 = (/  21,  21,  21, &
     21,  21 /) ! gl/1/2 gl/2/3 gl/4/3 gl/5/4 gl/1/5
  integer, parameter, private :: f0001m = 1
  integer, dimension(n_prt,n_flv), parameter, private :: table_flavor_states  &
     =  reshape ( (/ f0001 /), (/ n_prt, n_flv /) )
  integer, dimension(n_in), parameter, private ::  fi0001 = (/  21,  21  &
     /) ! gl/1/2 gl/2/3
  integer, parameter, private :: fi0001m = 1
  integer, dimension(n_in,n_flv_in), parameter, private :: table_flavor_states_in  &
     =  reshape ( (/ fi0001 /), (/ n_in, n_flv_in /) )
  integer, dimension(n_out), parameter, private ::  fo0001 = (/  21,  21,  21  &
     /) ! gl/1/3 gl/2/4 gl/3/5
  integer, parameter, private :: fo0001m = 1
  integer, dimension(n_out,n_flv_out), parameter, private :: table_flavor_states_out  &
     =  reshape ( (/ fo0001 /), (/ n_out, n_flv_out /) )

  logical, dimension(n_hel,n_flv) :: flv_hel_flag

  integer, dimension(n_prt,0), private :: table_flavor_zeros
  integer, dimension(n_in,0), private  :: table_flavor_zeros_in
  integer, dimension(n_out,0), private :: table_flavor_zeros_out

  integer, dimension(n_prt), parameter, private :: c0001 = (/ 2, 3, 4, 5, 1 /)
  integer, dimension(n_prt), parameter, private :: c0002 = (/ 2, 3, 5, 1, 4 /)
  integer, dimension(n_prt), parameter, private :: c0003 = (/ 2, 4, 1, 5, 3 /)
  integer, dimension(n_prt), parameter, private :: c0004 = (/ 2, 4, 5, 3, 1 /)
  integer, dimension(n_prt), parameter, private :: c0005 = (/ 2, 5, 1, 3, 4 /)
  integer, dimension(n_prt), parameter, private :: c0006 = (/ 2, 5, 4, 1, 3 /)
  integer, dimension(n_prt), parameter, private :: c0007 = (/ 3, 1, 4, 5, 2 /)
  integer, dimension(n_prt), parameter, private :: c0008 = (/ 3, 1, 5, 2, 4 /)
  integer, dimension(n_prt), parameter, private :: c0009 = (/ 3, 4, 2, 5, 1 /)
  integer, dimension(n_prt), parameter, private :: c0010 = (/ 3, 4, 5, 1, 2 /)
  integer, dimension(n_prt), parameter, private :: c0011 = (/ 3, 5, 2, 1, 4 /)
  integer, dimension(n_prt), parameter, private :: c0012 = (/ 3, 5, 4, 2, 1 /)
  integer, dimension(n_prt), parameter, private :: c0013 = (/ 4, 1, 2, 5, 3 /)
  integer, dimension(n_prt), parameter, private :: c0014 = (/ 4, 1, 5, 3, 2 /)
  integer, dimension(n_prt), parameter, private :: c0015 = (/ 4, 3, 1, 5, 2 /)
  integer, dimension(n_prt), parameter, private :: c0016 = (/ 4, 3, 5, 2, 1 /)
  integer, dimension(n_prt), parameter, private :: c0017 = (/ 4, 5, 1, 2, 3 /)
  integer, dimension(n_prt), parameter, private :: c0018 = (/ 4, 5, 2, 3, 1 /)
  integer, dimension(n_prt), parameter, private :: c0019 = (/ 5, 1, 2, 3, 4 /)
  integer, dimension(n_prt), parameter, private :: c0020 = (/ 5, 1, 4, 2, 3 /)
  integer, dimension(n_prt), parameter, private :: c0021 = (/ 5, 3, 1, 2, 4 /)
  integer, dimension(n_prt), parameter, private :: c0022 = (/ 5, 3, 4, 1, 2 /)
  integer, dimension(n_prt), parameter, private :: c0023 = (/ 5, 4, 1, 3, 2 /)
  integer, dimension(n_prt), parameter, private :: c0024 = (/ 5, 4, 2, 1, 3 /)
  integer, dimension(n_prt,n_cflow), parameter, private :: table_color_flows  &
     = reshape ( (/ c0001, c0002, c0003, c0004, c0005, c0006, c0007, c0008,  &
     c0009, c0010, c0011, c0012, c0013, c0014, c0015, c0016, c0017, c0018, c0019, &
     c0020, c0021, c0022, c0023, c0024 /), (/ n_prt, n_cflow /) )
  integer, dimension(n_prt), parameter, private :: a0001 = (/ 5, 1, 2, 3, 4 /)
  integer, dimension(n_prt), parameter, private :: a0002 = (/ 4, 1, 2, 5, 3 /)
  integer, dimension(n_prt), parameter, private :: a0003 = (/ 3, 1, 5, 2, 4 /)
  integer, dimension(n_prt), parameter, private :: a0004 = (/ 5, 1, 4, 2, 3 /)
  integer, dimension(n_prt), parameter, private :: a0005 = (/ 3, 1, 4, 5, 2 /)
  integer, dimension(n_prt), parameter, private :: a0006 = (/ 4, 1, 5, 3, 2 /)
  integer, dimension(n_prt), parameter, private :: a0007 = (/ 2, 5, 1, 3, 4 /)
  integer, dimension(n_prt), parameter, private :: a0008 = (/ 2, 4, 1, 5, 3 /)
  integer, dimension(n_prt), parameter, private :: a0009 = (/ 5, 3, 1, 2, 4 /)
  integer, dimension(n_prt), parameter, private :: a0010 = (/ 4, 5, 1, 2, 3 /)
  integer, dimension(n_prt), parameter, private :: a0011 = (/ 4, 3, 1, 5, 2 /)
  integer, dimension(n_prt), parameter, private :: a0012 = (/ 5, 4, 1, 3, 2 /)
  integer, dimension(n_prt), parameter, private :: a0013 = (/ 2, 3, 5, 1, 4 /)
  integer, dimension(n_prt), parameter, private :: a0014 = (/ 2, 5, 4, 1, 3 /)
  integer, dimension(n_prt), parameter, private :: a0015 = (/ 3, 5, 2, 1, 4 /)
  integer, dimension(n_prt), parameter, private :: a0016 = (/ 5, 4, 2, 1, 3 /)
  integer, dimension(n_prt), parameter, private :: a0017 = (/ 3, 4, 5, 1, 2 /)
  integer, dimension(n_prt), parameter, private :: a0018 = (/ 5, 3, 4, 1, 2 /)
  integer, dimension(n_prt), parameter, private :: a0019 = (/ 2, 3, 4, 5, 1 /)
  integer, dimension(n_prt), parameter, private :: a0020 = (/ 2, 4, 5, 3, 1 /)
  integer, dimension(n_prt), parameter, private :: a0021 = (/ 3, 4, 2, 5, 1 /)
  integer, dimension(n_prt), parameter, private :: a0022 = (/ 4, 5, 2, 3, 1 /)
  integer, dimension(n_prt), parameter, private :: a0023 = (/ 3, 5, 4, 2, 1 /)
  integer, dimension(n_prt), parameter, private :: a0024 = (/ 4, 3, 5, 2, 1 /)
  integer, dimension(n_prt,n_cflow), parameter, private :: table_anticolor_flows  &
     = reshape ( (/ a0001, a0002, a0003, a0004, a0005, a0006, a0007, a0008,  &
     a0009, a0010, a0011, a0012, a0013, a0014, a0015, a0016, a0017, a0018, a0019, &
     a0020, a0021, a0022, a0023, a0024 /), (/ n_prt, n_cflow/) )
  integer, dimension(n_cflow), parameter, private :: fn0001 = (/ 243, 27, 27, &
     27, 27, 27, 27, 3, 27, 3, 3, 27, 27, 3, 27, 27, 3, 27, 3, 27, 27, 27, 3, &
     3 /)
  integer, dimension(n_cflow), parameter, private :: fd0001 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0001 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0002 = (/ 27, 243, 27, &
     27, 27, 27, 3, 27, 3, 27, 27, 3, 3, 27, 27, 27, 3, 3, 27, 3, 27, 27, 3, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0002 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0002 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0003 = (/ 27, 27, 243, &
     27, 27, 27, 27, 3, 27, 27, 3, 3, 27, 3, 27, 3, 27, 3, 3, 27, 27, 3, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0003 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0003 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0004 = (/ 27, 27, 27, &
     243, 27, 27, 3, 27, 27, 27, 3, 27, 3, 27, 3, 27, 3, 27, 27, 3, 3, 3, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0004 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0004 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0005 = (/ 27, 27, 27, &
     27, 243, 27, 3, 27, 3, 3, 27, 27, 3, 27, 27, 3, 27, 27, 27, 3, 27, 3, 27, &
     3 /)
  integer, dimension(n_cflow), parameter, private :: fd0005 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0005 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0006 = (/ 27, 27, 27, &
     27, 27, 243, 27, 3, 3, 27, 27, 27, 27, 3, 3, 3, 27, 27, 3, 27, 3, 27, 3, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0006 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0006 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0007 = (/ 27, 3, 27,  &
     3, 3, 27, 243, 27, 27, 27, 27, 27, 27, 27, 27, 3, 3, 3, 27, 27, 3, 27,  &
     27, 3 /)
  integer, dimension(n_cflow), parameter, private :: fd0007 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0007 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0008 = (/ 3, 27, 3, 27, &
     27, 3, 27, 243, 27, 27, 27, 27, 27, 27, 3, 27, 27, 3, 27, 27, 27, 3, 3, &
     3 /)
  integer, dimension(n_cflow), parameter, private :: fd0008 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0008 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0009 = (/ 27, 3, 27,  &
     27, 3, 3, 27, 27, 243, 27, 27, 27, 27, 3, 27, 27, 3, 27, 27, 3, 3, 3, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0009 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0009 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0010 = (/ 3, 27, 27,  &
     27, 3, 27, 27, 27, 27, 243, 27, 27, 3, 27, 27, 27, 3, 3, 3, 3, 3, 27, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0010 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0010 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0011 = (/ 3, 27, 3, 3, &
     27, 27, 27, 27, 27, 27, 243, 27, 27, 3, 3, 3, 27, 27, 27, 3, 27, 27, 3, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0011 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0011 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0012 = (/ 27, 3, 3, 27, &
     27, 27, 27, 27, 27, 27, 27, 243, 3, 3, 3, 27, 27, 27, 3, 27, 27, 27, 3, &
     3 /)
  integer, dimension(n_cflow), parameter, private :: fd0012 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0012 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0013 = (/ 27, 3, 27,  &
     3, 3, 27, 27, 27, 27, 3, 27, 3, 243, 27, 27, 27, 27, 27, 27, 27, 3, 3,  &
     3, 27 /)
  integer, dimension(n_cflow), parameter, private :: fd0013 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0013 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0014 = (/ 3, 27, 3, 27, &
     27, 3, 27, 27, 3, 27, 3, 3, 27, 243, 27, 27, 27, 27, 27, 27, 3, 27, 27, &
     3 /)
  integer, dimension(n_cflow), parameter, private :: fd0014 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0014 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0015 = (/ 27, 27, 27, &
     3, 27, 3, 27, 3, 27, 27, 3, 3, 27, 27, 243, 27, 27, 27, 3, 3, 27, 27, 27, &
     3 /)
  integer, dimension(n_cflow), parameter, private :: fd0015 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0015 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0016 = (/ 27, 27, 3,  &
     27, 3, 3, 3, 27, 27, 27, 3, 27, 27, 27, 27, 243, 27, 27, 3, 27, 27, 27, &
     3, 3 /)
  integer, dimension(n_cflow), parameter, private :: fd0016 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0016 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0017 = (/ 3, 3, 27, 3, &
     27, 27, 3, 27, 3, 3, 27, 27, 27, 27, 27, 27, 243, 27, 3, 27, 27, 3, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0017 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0017 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0018 = (/ 27, 3, 3, 27, &
     27, 27, 3, 3, 27, 3, 27, 27, 27, 27, 27, 27, 27, 243, 27, 3, 3, 3, 27,  &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0018 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0018 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0019 = (/ 3, 27, 3, 27, &
     27, 3, 27, 27, 27, 3, 27, 3, 27, 27, 3, 3, 3, 27, 243, 27, 27, 27, 27,  &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0019 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0019 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0020 = (/ 27, 3, 27,  &
     3, 3, 27, 27, 27, 3, 3, 3, 27, 27, 27, 3, 27, 27, 3, 27, 243, 27, 27, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0020 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0020 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0021 = (/ 27, 27, 27, &
     3, 27, 3, 3, 27, 3, 3, 27, 27, 3, 3, 27, 27, 27, 3, 27, 27, 243, 27, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0021 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0021 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0022 = (/ 27, 27, 3,  &
     3, 3, 27, 27, 3, 3, 27, 27, 27, 3, 27, 27, 27, 3, 3, 27, 27, 27, 243, 27, &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0022 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0022 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0023 = (/ 3, 3, 27, 27, &
     27, 3, 27, 3, 27, 27, 3, 3, 3, 27, 27, 3, 27, 27, 27, 27, 27, 27, 243,  &
     27 /)
  integer, dimension(n_cflow), parameter, private :: fd0023 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0023 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow), parameter, private :: fn0024 = (/ 3, 27, 27,  &
     27, 3, 27, 3, 3, 27, 27, 27, 3, 27, 3, 3, 3, 27, 27, 27, 27, 27, 27, 27, &
     243 /)
  integer, dimension(n_cflow), parameter, private :: fd0024 = (/ 64, 64, 64, &
     64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, &
     64, 64, 64 /)
  logical, dimension(n_cflow), parameter, private :: ff0024 = (/ T, T, T, T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)
  integer, dimension(n_cflow,n_cflow), parameter, private :: flow_num = reshape  &
     ( (/ fn0001, fn0002, fn0003, fn0004, fn0005, fn0006, fn0007, fn0008, fn0009, &
     fn0010, fn0011, fn0012, fn0013, fn0014, fn0015, fn0016, fn0017, fn0018, &
     fn0019, fn0020, fn0021, fn0022, fn0023, fn0024 /), (/ n_cflow, n_cflow /) )
  integer, dimension(n_cflow,n_cflow), parameter, private :: flow_den = reshape  &
     ( (/ fd0001, fd0002, fd0003, fd0004, fd0005, fd0006, fd0007, fd0008, fd0009, &
     fd0010, fd0011, fd0012, fd0013, fd0014, fd0015, fd0016, fd0017, fd0018, &
     fd0019, fd0020, fd0021, fd0022, fd0023, fd0024 /), (/ n_cflow, n_cflow /) )
  logical, dimension(n_cflow,n_cflow), parameter, private :: flow_flag = reshape  &
     ( (/ ff0001, ff0002, ff0003, ff0004, ff0005, ff0006, ff0007, ff0008, ff0009, &
     ff0010, ff0011, ff0012, ff0013, ff0014, ff0015, ff0016, ff0017, ff0018, &
     ff0019, ff0020, ff0021, ff0022, ff0023, ff0024 /), (/ n_cflow, n_cflow /) )
  real(kind=omega_prec), dimension(n_cflow,n_cflow), save, private :: flow_coeff
  logical, dimension(n_cflow), parameter, private :: flow_is_physical = (/ T, &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T /)

  logical, dimension(n_cflow), parameter, private :: fc0001 = (/T, T, T, T,  &
     T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T/)
  logical, dimension(n_cflow,n_flv), parameter, private :: flv_col_flag = reshape  &
     ( (/ fc0001 /), (/ n_cflow, n_flv/) )

  integer, dimension(n_flv), parameter, private :: table_symmetry = (/   1 /)

contains

  subroutine allocate_zero_1 (zero)
    integer, dimension(:,:), pointer :: zero
    allocate (zero(size(table_spin_states,dim=2),  size(table_flavor_states, &
       dim=2)))
    zero = 0
  end subroutine allocate_zero_1

  subroutine allocate_zero_2 (zero)
    integer, dimension(:,:,:,:), pointer :: zero
    allocate(zero(size(table_spin_states_in,dim=2),  size(table_flavor_states_in, &
       dim=2),  size(table_spin_states_out,dim=2),  size(table_flavor_states_out, &
       dim=2)))
    zero = 0
  end subroutine allocate_zero_2

  subroutine create ()
    interface
      function omp_get_max_threads () result (res)
        integer :: res
      end function omp_get_max_threads
    end interface

    if (omp_get_max_threads () > 8) then
       print *
       print *, "FATAL: trying to run ", omp_get_max_threads (), "threads, but only"
       print *, "8 were provided for at configure and build time. To get rid of"
       print *, "this error, please rebuild with a higher number of threads"
       print *, "(configure --enable-max-threads=nt_max) or reduce the number of"
       print *, "actual threads by setting OMP_MAX_THREADS."
       call exit (1)
    end if
    flow_coeff = real (flow_num, kind=omega_prec) / real (flow_den, kind=omega_prec)
  end subroutine create
  subroutine reset (par)
    type(parameter_set), intent(in) :: par
    call import_from_whizard (par)
  end subroutine reset
  subroutine destroy ()
  end subroutine destroy

  pure function number_particles () result (n)
    integer :: n
    n = size (table_flavor_states, dim=1)
  end function number_particles
  pure function number_particles_in () result (n)
    integer :: n
    n = size (table_flavor_states_in, dim=1)
  end function number_particles_in
  pure function number_particles_out () result (n)
    integer :: n
    n = size (table_flavor_states_out, dim=1)
  end function number_particles_out

  pure function number_spin_states () result (n)
    integer :: n
    n = size (table_spin_states, dim=2)
  end function number_spin_states
  pure subroutine spin_states (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_spin_states
  end subroutine spin_states
  pure function number_spin_states_in () result (n)
    integer :: n
    n = size (table_spin_states_in, dim=2)
  end function number_spin_states_in
  pure subroutine spin_states_in (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_spin_states_in
  end subroutine spin_states_in
  pure function number_spin_states_out () result (n)
    integer :: n
    n = size (table_spin_states_out, dim=2)
  end function number_spin_states_out
  pure subroutine spin_states_out (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_spin_states_out
  end subroutine spin_states_out

  pure function number_flavor_states () result (n)
    integer :: n
    n = size (table_flavor_states, dim=2)
  end function number_flavor_states
  pure subroutine flavor_states (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_states
  end subroutine flavor_states
  pure function number_flavor_states_in () result (n)
    integer :: n
    n = size (table_flavor_states_in, dim=2)
  end function number_flavor_states_in
  pure subroutine flavor_states_in (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_states_in
  end subroutine flavor_states_in
  pure function number_flavor_states_out () result (n)
    integer :: n
    n = size (table_flavor_states_out, dim=2)
  end function number_flavor_states_out
  pure subroutine flavor_states_out (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_states_out
  end subroutine flavor_states_out

  function number_flavor_zeros () result (n)
    integer :: n
    n = 0
  end function number_flavor_zeros
  subroutine flavor_zeros (a)
    integer, dimension(:,:) :: a
    a = table_flavor_zeros
  end subroutine flavor_zeros
  function number_flavor_zeros_in () result (n)
    integer :: n
    n = 0
  end function number_flavor_zeros_in
  subroutine flavor_zeros_in (a)
    integer, dimension(:,:) :: a
    a = table_flavor_zeros_in
  end subroutine flavor_zeros_in
  function number_flavor_zeros_out () result (n)
    integer :: n
    n = 0
  end function number_flavor_zeros_out
  subroutine flavor_zeros_out (a)
    integer, dimension(:,:) :: a
    a = table_flavor_zeros_out
  end subroutine flavor_zeros_out

  function number_color_flows () result (n)
    integer :: n
    n = size (table_color_flows, dim=2)
  end function number_color_flows
  subroutine color_flows (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_color_flows
  end subroutine color_flows
  subroutine anticolor_flows (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_anticolor_flows
  end subroutine anticolor_flows

  subroutine calculate_amplitudes (amp, k, zero_ct, n)
    use test_decl
    use test_pamp_21_21_21_21_21
    integer :: nt
    complex(kind=omega_prec), dimension(:,:,:), intent(out) :: amp
    integer, dimension(:,:,:,:), intent(inout) :: zero_ct
    integer, intent(in) :: n
    integer, parameter :: SAMPLE = 10, REPEAT = 5
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    p1 = - k(:,1) ! incoming gl/1/2
    p2 = - k(:,2) ! incoming gl/2/3
    p3 =   k(:,3) ! outgoing gl/4/3
    p4 =   k(:,4) ! outgoing gl/5/4
    p5 =   k(:,5) ! outgoing gl/1/5
    p12 = p1 + p2
    p23 = p2 + p3
    p34 = p3 + p4
    p15 = p1 + p5
    p45 = p4 + p5
    p14 = p1 + p4
    p35 = p3 + p5
    p13 = p1 + p3
    p24 = p2 + p4
    p25 = p2 + p5
    amp = 0
    flv_hel_flag = .false.
    !$OMP PARALLEL DEFAULT(SHARED) PRIVATE(h, hi, ho, nt)
    !$OMP DO
    do h =1, n_hel
       hi = (h - 1) / n_hel_out + 1
       ho = mod (h - 1, n_hel_out) + 1
       nt = omp_get_thread_num () + 1
       if (zero_ct(hi,1,ho,1) > REPEAT)  cycle
       s(:, nt) = table_spin_states (:,h)
       call calc_test_pamp_21_21_21_21_21 (nt)
       ! flavor: [21, 21, 21, 21, 21]   color: (2, 3, 4, 5, 1)
       !                                       (5, 1, 2, 3, 4)
       amp(1,h,1) = + bk1_1_1(nt) + bk1_1_2(nt) + bk1_1_3(nt) + bk1_1_4(nt) + bk1_1_5(nt) + bk1_1_6(nt)  &
          + bk1_1_7(nt) + bk1_1_8(nt)
       ! amp(1,h,1) = amp(1,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(1,h,1) /= 0
       amp(1,h,1) = amp(1,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (2, 3, 5, 1, 4)
       !                                       (4, 1, 2, 5, 3)
       amp(2,h,1) = + bk2_1_1(nt) + bk2_1_2(nt) + bk2_1_3(nt) + bk2_1_4(nt) + bk2_1_5(nt) + bk2_1_6(nt)  &
          + bk2_1_7(nt) + bk2_1_8(nt)
       ! amp(2,h,1) = amp(2,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(2,h,1) /= 0
       amp(2,h,1) = amp(2,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (2, 4, 1, 5, 3)
       !                                       (3, 1, 5, 2, 4)
       amp(3,h,1) = + bk3_1_1(nt) + bk3_1_2(nt) + bk3_1_3(nt) + bk3_1_4(nt) + bk3_1_5(nt) + bk3_1_6(nt)  &
          + bk3_1_7(nt) + bk3_1_8(nt)
       ! amp(3,h,1) = amp(3,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(3,h,1) /= 0
       amp(3,h,1) = amp(3,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (2, 4, 5, 3, 1)
       !                                       (5, 1, 4, 2, 3)
       amp(4,h,1) = + bk4_1_1(nt) + bk4_1_2(nt) + bk4_1_3(nt) + bk4_1_4(nt) + bk4_1_5(nt) + bk4_1_6(nt)  &
          + bk4_1_7(nt) + bk4_1_8(nt)
       ! amp(4,h,1) = amp(4,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(4,h,1) /= 0
       amp(4,h,1) = amp(4,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (2, 5, 1, 3, 4)
       !                                       (3, 1, 4, 5, 2)
       amp(5,h,1) = + bk5_1_1(nt) + bk5_1_2(nt) + bk5_1_3(nt) + bk5_1_4(nt) + bk5_1_5(nt) + bk5_1_6(nt)  &
          + bk5_1_7(nt) + bk5_1_8(nt)
       ! amp(5,h,1) = amp(5,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(5,h,1) /= 0
       amp(5,h,1) = amp(5,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (2, 5, 4, 1, 3)
       !                                       (4, 1, 5, 3, 2)
       amp(6,h,1) = + bk6_1_1(nt) + bk6_1_2(nt) + bk6_1_3(nt) + bk6_1_4(nt) + bk6_1_5(nt) + bk6_1_6(nt)  &
          + bk6_1_7(nt) + bk6_1_8(nt)
       ! amp(6,h,1) = amp(6,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(6,h,1) /= 0
       amp(6,h,1) = amp(6,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (3, 1, 4, 5, 2)
       !                                       (2, 5, 1, 3, 4)
       amp(7,h,1) = + bk7_1_1(nt) + bk7_1_2(nt) + bk7_1_3(nt) + bk7_1_4(nt) + bk7_1_5(nt) + bk7_1_6(nt)  &
          + bk7_1_7(nt) + bk7_1_8(nt)
       ! amp(7,h,1) = amp(7,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(7,h,1) /= 0
       amp(7,h,1) = amp(7,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (3, 1, 5, 2, 4)
       !                                       (2, 4, 1, 5, 3)
       amp(8,h,1) = + bk8_1_1(nt) + bk8_1_2(nt) + bk8_1_3(nt) + bk8_1_4(nt) + bk8_1_5(nt) + bk8_1_6(nt)  &
          + bk8_1_7(nt) + bk8_1_8(nt)
       ! amp(8,h,1) = amp(8,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(8,h,1) /= 0
       amp(8,h,1) = amp(8,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (3, 4, 2, 5, 1)
       !                                       (5, 3, 1, 2, 4)
       amp(9,h,1) = + bk9_1_1(nt) + bk9_1_2(nt) + bk9_1_3(nt) + bk9_1_4(nt) + bk9_1_5(nt) + bk9_1_6(nt)  &
          + bk9_1_7(nt) + bk9_1_8(nt)
       ! amp(9,h,1) = amp(9,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(9,h,1) /= 0
       amp(9,h,1) = amp(9,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (3, 4, 5, 1, 2)
       !                                       (4, 5, 1, 2, 3)
       amp(10,h,1) = + bk10_1_1(nt) + bk10_1_2(nt) + bk10_1_3(nt) + bk10_1_4(nt) + bk10_1_5(nt)  &
          + bk10_1_6(nt) + bk10_1_7(nt) + bk10_1_8(nt)
       ! amp(10,h,1) = amp(10,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(10,h,1) /= 0
       amp(10,h,1) = amp(10,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (3, 5, 2, 1, 4)
       !                                       (4, 3, 1, 5, 2)
       amp(11,h,1) = + bk11_1_1(nt) + bk11_1_2(nt) + bk11_1_3(nt) + bk11_1_4(nt) + bk11_1_5(nt)  &
          + bk11_1_6(nt) + bk11_1_7(nt) + bk11_1_8(nt)
       ! amp(11,h,1) = amp(11,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(11,h,1) /= 0
       amp(11,h,1) = amp(11,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (3, 5, 4, 2, 1)
       !                                       (5, 4, 1, 3, 2)
       amp(12,h,1) = + bk12_1_1(nt) + bk12_1_2(nt) + bk12_1_3(nt) + bk12_1_4(nt) + bk12_1_5(nt)  &
          + bk12_1_6(nt) + bk12_1_7(nt) + bk12_1_8(nt)
       ! amp(12,h,1) = amp(12,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(12,h,1) /= 0
       amp(12,h,1) = amp(12,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (4, 1, 2, 5, 3)
       !                                       (2, 3, 5, 1, 4)
       amp(13,h,1) = + bk13_1_1(nt) + bk13_1_2(nt) + bk13_1_3(nt) + bk13_1_4(nt) + bk13_1_5(nt)  &
          + bk13_1_6(nt) + bk13_1_7(nt) + bk13_1_8(nt)
       ! amp(13,h,1) = amp(13,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(13,h,1) /= 0
       amp(13,h,1) = amp(13,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (4, 1, 5, 3, 2)
       !                                       (2, 5, 4, 1, 3)
       amp(14,h,1) = + bk14_1_1(nt) + bk14_1_2(nt) + bk14_1_3(nt) + bk14_1_4(nt) + bk14_1_5(nt)  &
          + bk14_1_6(nt) + bk14_1_7(nt) + bk14_1_8(nt)
       ! amp(14,h,1) = amp(14,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(14,h,1) /= 0
       amp(14,h,1) = amp(14,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (4, 3, 1, 5, 2)
       !                                       (3, 5, 2, 1, 4)
       amp(15,h,1) = + bk15_1_1(nt) + bk15_1_2(nt) + bk15_1_3(nt) + bk15_1_4(nt) + bk15_1_5(nt)  &
          + bk15_1_6(nt) + bk15_1_7(nt) + bk15_1_8(nt)
       ! amp(15,h,1) = amp(15,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(15,h,1) /= 0
       amp(15,h,1) = amp(15,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (4, 3, 5, 2, 1)
       !                                       (5, 4, 2, 1, 3)
       amp(16,h,1) = + bk16_1_1(nt) + bk16_1_2(nt) + bk16_1_3(nt) + bk16_1_4(nt) + bk16_1_5(nt)  &
          + bk16_1_6(nt) + bk16_1_7(nt) + bk16_1_8(nt)
       ! amp(16,h,1) = amp(16,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(16,h,1) /= 0
       amp(16,h,1) = amp(16,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (4, 5, 1, 2, 3)
       !                                       (3, 4, 5, 1, 2)
       amp(17,h,1) = + bk17_1_1(nt) + bk17_1_2(nt) + bk17_1_3(nt) + bk17_1_4(nt) + bk17_1_5(nt)  &
          + bk17_1_6(nt) + bk17_1_7(nt) + bk17_1_8(nt)
       ! amp(17,h,1) = amp(17,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(17,h,1) /= 0
       amp(17,h,1) = amp(17,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (4, 5, 2, 3, 1)
       !                                       (5, 3, 4, 1, 2)
       amp(18,h,1) = + bk18_1_1(nt) + bk18_1_2(nt) + bk18_1_3(nt) + bk18_1_4(nt) + bk18_1_5(nt)  &
          + bk18_1_6(nt) + bk18_1_7(nt) + bk18_1_8(nt)
       ! amp(18,h,1) = amp(18,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(18,h,1) /= 0
       amp(18,h,1) = amp(18,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (5, 1, 2, 3, 4)
       !                                       (2, 3, 4, 5, 1)
       amp(19,h,1) = + bk19_1_1(nt) + bk19_1_2(nt) + bk19_1_3(nt) + bk19_1_4(nt) + bk19_1_5(nt)  &
          + bk19_1_6(nt) + bk19_1_7(nt) + bk19_1_8(nt)
       ! amp(19,h,1) = amp(19,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(19,h,1) /= 0
       amp(19,h,1) = amp(19,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (5, 1, 4, 2, 3)
       !                                       (2, 4, 5, 3, 1)
       amp(20,h,1) = + bk20_1_1(nt) + bk20_1_2(nt) + bk20_1_3(nt) + bk20_1_4(nt) + bk20_1_5(nt)  &
          + bk20_1_6(nt) + bk20_1_7(nt) + bk20_1_8(nt)
       ! amp(20,h,1) = amp(20,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(20,h,1) /= 0
       amp(20,h,1) = amp(20,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (5, 3, 1, 2, 4)
       !                                       (3, 4, 2, 5, 1)
       amp(21,h,1) = + bk21_1_1(nt) + bk21_1_2(nt) + bk21_1_3(nt) + bk21_1_4(nt) + bk21_1_5(nt)  &
          + bk21_1_6(nt) + bk21_1_7(nt) + bk21_1_8(nt)
       ! amp(21,h,1) = amp(21,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(21,h,1) /= 0
       amp(21,h,1) = amp(21,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (5, 3, 4, 1, 2)
       !                                       (4, 5, 2, 3, 1)
       amp(22,h,1) = + bk22_1_1(nt) + bk22_1_2(nt) + bk22_1_3(nt) + bk22_1_4(nt) + bk22_1_5(nt)  &
          + bk22_1_6(nt) + bk22_1_7(nt) + bk22_1_8(nt)
       ! amp(22,h,1) = amp(22,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(22,h,1) /= 0
       amp(22,h,1) = amp(22,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (5, 4, 1, 3, 2)
       !                                       (3, 5, 4, 2, 1)
       amp(23,h,1) = + bk23_1_1(nt) + bk23_1_2(nt) + bk23_1_3(nt) + bk23_1_4(nt) + bk23_1_5(nt)  &
          + bk23_1_6(nt) + bk23_1_7(nt) + bk23_1_8(nt)
       ! amp(23,h,1) = amp(23,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(23,h,1) /= 0
       amp(23,h,1) = amp(23,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       ! flavor: [21, 21, 21, 21, 21]   color: (5, 4, 2, 1, 3)
       !                                       (4, 3, 5, 2, 1)
       amp(24,h,1) = + bk24_1_1(nt) + bk24_1_2(nt) + bk24_1_3(nt) + bk24_1_4(nt) + bk24_1_5(nt)  &
          + bk24_1_6(nt) + bk24_1_7(nt) + bk24_1_8(nt)
       ! amp(24,h,1) = amp(24,h,1) ! 3 vertices, 2 propagators
       flv_hel_flag(h,1) = flv_hel_flag(h,1) .or. amp(24,h,1) /= 0
       amp(24,h,1) = amp(24,h,1) / sqrt(6.0_omega_prec) ! symmetry factor
       ! Number of external adjoints: 5
       if (n <= SAMPLE) then
          if (all (abs(amp(:,h,:)) <= tiny(1._omega_prec)))  zero_ct(hi,1,ho, &
             1) = zero_ct(hi,1,ho,1) + 1
       end if
     end do
     !$OMP END DO
     !$OMP END PARALLEL
  end subroutine calculate_amplitudes

  function flv (fin, fout)
    integer, intent(in) :: fin, fout
    integer :: flv
    flv = 0
    select case (fin)
    case (1)
       select case (fout)
       case (1);  flv = 1   ! (/ 21, 21, 21, 21, 21 /)
       end select
    end select
  end function flv

  function flv_pdf (fin)
    integer, intent(in) :: fin
    integer, dimension(2) :: flv_pdf
    flv_pdf = 0
    select case (fin)
    case (1)
       flv_pdf = (/  21,  21 /)
    end select
  end function flv_pdf

  subroutine scatter_diagonal_nonzero (p, rho_in, rho_out, zero_ct, n)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: p
    real(kind=omega_prec), dimension(:,:), intent(in) :: rho_in
    real(kind=omega_prec), dimension(:,:), intent(inout) :: rho_out
    integer, dimension(:,:,:,:), intent(inout) :: zero_ct
    integer, intent(in) :: n
    integer :: fi, fo, f, hi, ho, h, c
    complex(kind=omega_prec), dimension(n_cflow,n_hel,n_flv) :: amp
    complex(kind=omega_prec), dimension(n_cflow) :: amp1, amp2
    call calculate_amplitudes (amp, p, zero_ct, n)
    rho_out = 0
    h = 0
    do hi = 1, n_hel_in
    do ho = 1, n_hel_out
       h = h + 1
       do fi = 1, n_flv_in
       do fo = 1, n_flv_out
          f = flv (fi, fo);  if (f == 0)  cycle
          if (.not. flv_hel_flag(h,f)) cycle
          amp1 = 0
          forall (c = 1:n_cflow, flv_col_flag(c,f))
            amp1(c) = sum (amp(:,h,f) * flow_coeff(:,c), flow_flag(:,c) .and.  &
               flv_col_flag(:,f))
          end forall
          amp2 = amp(:,h,f)
          rho_out(ho,fo) = rho_out(ho,fo) + dot_product (amp1, amp2) * rho_in( &
             hi,fi)
       end do
       end do
    end do
    end do
  end subroutine scatter_diagonal_nonzero

  subroutine scatter_nonzero (p, rho_in, rho_out, zero_ct, n)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: p
    complex(kind=omega_prec), dimension(:,:,:,:), intent(in) :: rho_in
    complex(kind=omega_prec), dimension(:,:,:,:), intent(inout) :: rho_out
    integer, dimension(:,:,:,:), intent(inout) :: zero_ct
    integer, intent(in) :: n
    integer :: fi, fo, f, hi1, hi2, ho1, ho2, h1, h2, c
    complex(kind=omega_prec), dimension(n_cflow,n_hel,n_flv) :: amp
    complex(kind=omega_prec), dimension(n_cflow) :: amp1, amp2
    call calculate_amplitudes (amp, p, zero_ct, n)
    rho_out = 0
    h1 = 0
    do hi1 = 1, n_hel_in
    do ho1 = 1, n_hel_out
       h1 = h1 + 1
       do hi2 = 1, n_hel_in
       do ho2 = 1, n_hel_out
          h2 = h2 + 1
          do fi = 1, n_flv_in
          do fo = 1, n_flv_out
             f = flv (fi, fo);  if (f == 0)  cycle
             if (.not. (flv_hel_flag(h1,f) .and. flv_hel_flag(h2,f))) cycle
             amp1 = 0
             forall (c = 1:n_cflow, flv_col_flag(c,f))
               amp1(c) = sum (amp(:,h1,f) * flow_coeff(:,c), flow_flag(:,c)  &
                  .and. flv_col_flag(:,f))
             end forall
             amp2 = amp(:,h2,f)
             rho_out(ho1,fo,ho2,fo) = rho_out(ho1,fo,ho2,fo) + dot_product ( &
                amp1, amp2) * rho_in(hi1,fi,hi2,fi)
          end do
          end do
       end do
       end do
    end do
    end do
  end subroutine scatter_nonzero

  subroutine scatter_diagonal_colored_nz (p, rho_in, rho_out, zero_ct, n)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: p
    real(kind=omega_prec), dimension(:,:), intent(in) :: rho_in
    real(kind=omega_prec), dimension(:,:,:), intent(inout) :: rho_out
    integer, dimension(:,:,:,:), intent(inout) :: zero_ct
    integer, intent(in) :: n
    integer :: fi, fo, f, hi, ho, h, c
    complex(kind=omega_prec), dimension(n_cflow,n_hel,n_flv) :: amp
    real(kind=omega_prec), dimension(n_cflow) :: pcol
    real(kind=omega_prec) :: sqme, sum_pcol
    complex(kind=omega_prec), dimension(n_cflow) :: amp1, amp2
    call calculate_amplitudes (amp, p, zero_ct, n)
    rho_out = 0
    pcol = 0
    h = 0
    do hi = 1, n_hel_in
    do ho = 1, n_hel_out
       h = h + 1
       do fi = 1, n_flv_in
       do fo = 1, n_flv_out
          f = flv (fi, fo);  if (f == 0)  cycle
          if (.not. flv_hel_flag(h,f)) cycle
          amp1 = 0
          forall (c = 1:n_cflow, flv_col_flag(c,f))
            amp1(c) = sum (amp(:,h,f) * flow_coeff(:,c), flow_flag(:,c) .and.  &
               flv_col_flag(:,f))
          end forall
          amp2 = amp(:,h,f)
          sqme = dot_product (amp1, amp2) * rho_in(hi,fi)
          where (flow_is_physical)
             pcol(:) = abs (amp(:,h,f))**2
          end where
          sum_pcol = sum (pcol)
          if (sum_pcol /= 0) then
             rho_out(:,ho,fo) = rho_out(:,ho,fo) + sqme * pcol(:) / sum_pcol
          end if
       end do
       end do
    end do
    end do
  end subroutine scatter_diagonal_colored_nz

  subroutine scatter_colored_nonzero (p, rho_in, rho_out, rho_col_out, zero_ct, &
     n)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: p
    complex(kind=omega_prec), dimension(:,:,:,:), intent(in) :: rho_in
    complex(kind=omega_prec), dimension(:,:,:,:), intent(inout) :: rho_out
    complex(kind=omega_prec), dimension(:,:,:,:,:), intent(inout) :: rho_col_out
    integer, dimension(:,:,:,:), intent(inout) :: zero_ct
    integer, intent(in) :: n
    integer :: fi, fo, f, hi1, hi2, ho1, ho2, h1, h2, c
    complex(kind=omega_prec), dimension(n_cflow,n_hel,n_flv) :: amp
    complex(kind=omega_prec), dimension(n_cflow) :: amp1, amp2
    call calculate_amplitudes (amp, p, zero_ct, n)
    rho_out = 0
    rho_col_out = 0
    h1 = 0
    do hi1 = 1, n_hel_in
    do ho1 = 1, n_hel_out
       h1 = h1 + 1
       do hi2 = 1, n_hel_in
       do ho2 = 1, n_hel_out
          h2 = h2 + 1
          do fi = 1, n_flv_in
          do fo = 1, n_flv_out
             f = flv (fi, fo);  if (f == 0)  cycle
             if (.not. (flv_hel_flag(h1,f) .and. flv_hel_flag(h2,f))) cycle
             amp1 = 0
             forall (c = 1:n_cflow, flv_col_flag(c,f))
               amp1(c) = sum (amp(:,h1,f) * flow_coeff(:,c), flow_flag(:,c)  &
                  .and. flv_col_flag(:,f))
             end forall
             amp2 = amp(:,h2,f)
             rho_out(ho1,fo,ho2,fo) = rho_out(ho1,fo,ho2,fo) + dot_product ( &
                amp1, amp2) * rho_in(hi1,fi,hi2,fi)
             where (flow_is_physical)
                rho_col_out(:,ho1,fo,ho2,fo) = rho_col_out(:,ho1,fo,ho2,fo)  &
                   + amp(:,h1,f) * conjg (amp2(:)) * rho_in(hi1,fi,hi2,fi)
             end where
          end do
          end do
       end do
       end do
    end do
    end do
  end subroutine scatter_colored_nonzero

end module test
! O'Mega revision control information:
!    Colorize.Gauge(Models.SM):
!      Gauged Colorization Functor ( minimal electroweak standard model in unitarity gauge )
!      URL: /home/sources/ohl/ml/omega/src/models.ml,v 
!      revision: 326  checked in by reuter  at 2008-08-17 06:49:19 +0200 (Sun, 17 Aug 2008) 
!    Targets.Make_Fortran():
!      NB: non-gauge vector couplings are not available yet
!      URL: /home/sources/ohl/ml/omega/src/targets.ml,v 
!      revision: 326  checked in by reuter  at 2008-08-17 06:49:19 +0200 (Sun, 17 Aug 2008) 
!    Targets.Fortran_Fermions():
!      generates Fortran95 code for Dirac fermions
!      using revision 2000_10_A of module omega95
!      URL: /home/sources/ohl/ml/omega/src/targets.ml,v 
!      revision: 326  checked in by reuter  at 2008-08-17 06:49:19 +0200 (Sun, 17 Aug 2008) 
!    DAG.Graded():
!      Graded directed Acyclical Graph 
!      representing binary or n-ary trees
!      URL: svn+ssh://jr_reuter@svn.hepforge.org/hepforge/home/whizard/event-generators/whizard/branches/1.xx/omega-src/bundle/src/dAG.ml 
!      revision: 68  checked in by ohl  at 2007-11-22 12:11:19 +0100 (Thu, 22 Nov 2007) 
!    Topology.Mixed23:
!      phi**3 + phi**4 topology
!      URL: svn+ssh://jr_reuter@svn.hepforge.org/hepforge/home/whizard/event-generators/whizard/branches/1.xx/omega-src/bundle/src/topology.ml 
!      revision: 68  checked in by ohl  at 2007-11-22 12:11:19 +0100 (Thu, 22 Nov 2007) 
!    Momentum.Bits():
!      Finite disjoint sums of momenta
!      using bitfields as representation.
!      URL: svn+ssh://jr_reuter@svn.hepforge.org/hepforge/home/whizard/event-generators/whizard/branches/1.xx/omega-src/bundle/src/momentum.ml 
!      revision: 68  checked in by ohl  at 2007-11-22 12:11:19 +0100 (Thu, 22 Nov 2007) 
!    Fusion.Make():
!      Fusions for arbitrary topologies
!      URL: svn+ssh://jr_reuter@svn.hepforge.org/hepforge/home/whizard/event-generators/whizard/branches/1.xx/omega-src/bundle/src/fusion.ml 
!      revision: 326  checked in by reuter  at 2008-08-17 06:49:19 +0200 (Sun, 17 Aug 2008) 
